window.Gleam.initSearch([{"doc":"gleastsq","title":"gleastsq","content":"# gleastsq\n\n[![Package Version](https://img.shields.io/hexpm/v/gleastsq)](https://hex.pm/packages/gleastsq)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gleastsq/)\n\n```sh\ngleam add gleastsq\n```\n\n```gleam\nimport gleam/io\nimport gleastsq\n\nfn parabola(x: Float, params: List(Float)) -&gt; Float {\n  let assert [a, b, c] = params\n  a *. x *. x +. b *. x +. c\n}\n\npub fn main() {\n  let x = [0.0, 1.0, 2.0, 3.0, 4.0, 5.0]\n  let y = list.map(x, fn(x) { x *. x })\n  let initial_guess = [1.0, 1.0, 1.0]\n\n  let assert Ok(result) =\n    gleastsq.least_squares(\n      x,\n      y,\n      parabola,\n      initial_guess,\n      max_iterations: None,\n      epsilon: None,\n      tolerance: None,\n      lambda_reg: None,\n    )\n\n  io.debug(result) // [1.0, 0.0, 0.0] (within numerical error)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gleastsq&gt;.\n\n## Development\n\n```sh\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"nx","title":"NxTensor","content":"pub type NxTensor =\n  Dynamic\n\n\nSynonyms:\nnx.NxTensor\nnx NxTensor","url":"nx.html#NxTensor"},{"doc":"nx","title":"add","content":"pub fn add(a: Dynamic, b: Dynamic) -&gt; Dynamic\n\nSynonyms:\nnx.add\nnx add","url":"nx.html#add"},{"doc":"nx","title":"broadcast","content":"pub fn broadcast(a: Float, shape: a) -&gt; Dynamic\n\nSynonyms:\nnx.broadcast\nnx broadcast","url":"nx.html#broadcast"},{"doc":"nx","title":"divide","content":"pub fn divide(a: Dynamic, b: Float) -&gt; Dynamic\n\nSynonyms:\nnx.divide\nnx divide","url":"nx.html#divide"},{"doc":"nx","title":"dot","content":"pub fn dot(a: Dynamic, b: Dynamic) -&gt; Dynamic\n\nSynonyms:\nnx.dot\nnx dot","url":"nx.html#dot"},{"doc":"nx","title":"eye","content":"pub fn eye(n: Int) -&gt; Dynamic\n\nSynonyms:\nnx.eye\nnx eye","url":"nx.html#eye"},{"doc":"nx","title":"indexed_put","content":"pub fn indexed_put(\n  a: Dynamic,\n  indices: Dynamic,\n  value: Float,\n) -&gt; Dynamic\n\nSynonyms:\nnx.indexed_put\nnx indexed_put","url":"nx.html#indexed_put"},{"doc":"nx","title":"map","content":"pub fn map(a: Dynamic, f: fn(Dynamic) -&gt; Float) -&gt; Dynamic\n\nSynonyms:\nnx.map\nnx map","url":"nx.html#map"},{"doc":"nx","title":"multiply","content":"pub fn multiply(a: Dynamic, b: Float) -&gt; Dynamic\n\nSynonyms:\nnx.multiply\nnx multiply","url":"nx.html#multiply"},{"doc":"nx","title":"new_axis","content":"pub fn new_axis(a: Dynamic, axis: Int) -&gt; Dynamic\n\nSynonyms:\nnx.new_axis\nnx new_axis","url":"nx.html#new_axis"},{"doc":"nx","title":"norm","content":"pub fn norm(a: Dynamic) -&gt; Dynamic\n\nSynonyms:\nnx.norm\nnx norm","url":"nx.html#norm"},{"doc":"nx","title":"put_slice","content":"pub fn put_slice(\n  a: Dynamic,\n  indices: List(Int),\n  value: Dynamic,\n) -&gt; Dynamic\n\nSynonyms:\nnx.put_slice\nnx put_slice","url":"nx.html#put_slice"},{"doc":"nx","title":"shape","content":"pub fn shape(a: Dynamic) -&gt; #(Int)\n\nSynonyms:\nnx.shape\nnx shape","url":"nx.html#shape"},{"doc":"nx","title":"solve","content":"pub fn solve(a: Dynamic, b: Dynamic) -&gt; Dynamic\n\nSynonyms:\nnx.solve\nnx solve","url":"nx.html#solve"},{"doc":"nx","title":"subtract","content":"pub fn subtract(a: Dynamic, b: Dynamic) -&gt; Dynamic\n\nSynonyms:\nnx.subtract\nnx subtract","url":"nx.html#subtract"},{"doc":"nx","title":"tensor","content":"pub fn tensor(a: List(a)) -&gt; Dynamic\n\nSynonyms:\nnx.tensor\nnx tensor","url":"nx.html#tensor"},{"doc":"nx","title":"to_list_1d","content":"pub fn to_list_1d(a: Dynamic) -&gt; List(Float)\n\nSynonyms:\nnx.to_list_1d\nnx to_list_1d","url":"nx.html#to_list_1d"},{"doc":"nx","title":"to_list_2d","content":"pub fn to_list_2d(a: Dynamic) -&gt; List(List(Float))\n\nSynonyms:\nnx.to_list_2d\nnx to_list_2d","url":"nx.html#to_list_2d"},{"doc":"nx","title":"to_number","content":"pub fn to_number(a: Dynamic) -&gt; Float\n\nSynonyms:\nnx.to_number\nnx to_number","url":"nx.html#to_number"},{"doc":"nx","title":"transpose","content":"pub fn transpose(a: Dynamic) -&gt; Dynamic\n\nSynonyms:\nnx.transpose\nnx transpose","url":"nx.html#transpose"},{"doc":"nx","title":"nx","content":"","url":"nx.html"},{"doc":"gleastsq","title":"FitErrors","content":"pub opaque type FitErrors\n\n\nSynonyms:\ngleastsq.FitErrors\ngleastsq FitErrors","url":"gleastsq.html#FitErrors"},{"doc":"gleastsq","title":"least_squares","content":"pub fn least_squares(\n  x: List(Float),\n  y: List(Float),\n  func: fn(Float, List(Float)) -&gt; Float,\n  initial_params: List(Float),\n  max_iterations iterations: Option(Int),\n  epsilon epsilon: Option(Float),\n  tolerance tolerance: Option(Float),\n  lambda_reg lambda_reg: Option(Float),\n) -&gt; Result(List(Float), FitErrors)\n Compute the least squares fit of a function to a set of data points.\n\n ## Parameters:\n - `x`: The X axis of the data points as a list of floats.\n - `y`: The Y axis of the data points as a list of floats.\n - `func`: The function to fit to the data points. The function should take a float and a list of floats (the function coefficients) as arguments and return a float.\n - `initial_params`: The initial guess for the function coefficients.\n - `max_iterations`: The maximum number of iterations to perform. Default is 100.\n - `epsilon`: The epsilon value for the numerical derivative. Default is 0.0001.\n - `tolerance`: The tolerance for the convergence criterion. Default is 0.0001.\n - `lambda_reg`: The regularization parameter. Default is 0.0001.\n\n ## Examples\n\n \n import gleam/io\n import gleastsq\n \n fn parabola(x: Float, params: List(Float)) -&gt; Float {\n   let assert [a, b, c] = params\n   a *. x *. x +. b *. x +. c\n }\n \n pub fn main() {\n   let x = [0.0, 1.0, 2.0, 3.0, 4.0, 5.0]\n   let y = list.map(x, fn(x) { x *. x })\n   let initial_guess = [1.0, 1.0, 1.0]\n \n   let assert Ok(result) =\n     gleastsq.least_squares(\n       x,\n       y,\n       parabola,\n       initial_guess,\n       max_iterations: None,\n       epsilon: None,\n       tolerance: None,\n       lambda_reg: None,\n     )\n \n   io.debug(result) // [1.0, 0.0, 0.0] (within numerical error)\n }\n \nSynonyms:\ngleastsq.least_squares\ngleastsq least_squares","url":"gleastsq.html#least_squares"},{"doc":"gleastsq","title":"gleastsq","content":"","url":"gleastsq.html"}]);